怀抱观古今,寝食展戏谑。这篇文章主要讲述Linux之系统服务----自己创建服务相关的知识,希望能为你提供帮助。
【Linux之系统服务----自己创建服务】前几天比较忙,今天才闲下来,接着上次的内容讲,今天主要给大家讲讲service类型的配置文件,说的简单一些就是如何自己创建一个自己想要的服务。
一、了解service的参数信息
要想自己创建一个服务可不是一蹴而就的,最好的办法就是想去学习一下系统中已有的服务是什么样的,是以什么方式运行的,只有知己知彼才能百战不殆。先来看看sshd这个服务。
然后呢分析一下其中的内容,首先【UNIT】代表的是下面一段内容是对该UNIT本身的说明介绍,我这里的系统中关于这段的介绍共有四点 ,实际上是有很多的,我在网上找到了关于这个参数的简介:
接下来再了解一下【service】中有哪些参数
最后咱们要说的就是【install】install部分
二、创建自己的服务
上面已经学习了一些service类型的配置文件的内容,然后我们创建一个可以备份自己系统的服务来耍耍,哈哈哈
在/usr/lib/systemd/system下创建nginx.service文件内容如下(看应用需求也可以在 /usr/lib/systemd/usr下创建):
输入以下命令:
1)创建nginx脚本
#!/bin/sh
### BEGIN INIT INFO
# Provides:nginx
# Required-Start:$local_fs $remote_fs $network $syslog $named
# Required-Stop:$local_fs $remote_fs $network $syslog $named
# Default-Start:2 3 4 5
# Default-Stop:0 1 6
# Short-Description: starts the nginx web server
# Description:starts nginx using start-stop-daemon
### END INIT INFO
PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DAEMON=/usr/sbin/nginx
NAME=nginx
DESC=nginx
# Include nginx defaults if available
if [ -r /etc/default/nginx ];
then
. /etc/default/nginx
fi
test -x $DAEMON || exit 0
. /lib/init/vars.sh
. /lib/lsb/init-functions
# Try to extract nginx pidfile
PID=$(cat /etc/nginx/nginx.conf | grep -Ev ^\\s*# | awk BEGINRS="[;
]"if ($1 == "pid") print $2| head -n1)
if [ -z "$PID" ]
then
PID=/run/nginx.pid
fi
# Check if the ULIMIT is set in /etc/default/nginx
if [ -n "$ULIMIT" ];
then
# Set the ulimits
ulimit $ULIMIT
fi
#
# Function that starts the daemon/service
#
do_start()
# Return
#0 if daemon has been started
#1 if daemon was already running
#2 if daemon could not be started
start-stop-daemon --start --quiet --pidfile $PID --exec $DAEMON --test >
/dev/null \\
|| return 1
start-stop-daemon --start --quiet --pidfile $PID --exec $DAEMON -- \\
$DAEMON_OPTS 2>
/dev/null \\
|| return 2
test_nginx_config()
$DAEMON -t $DAEMON_OPTS >
/dev/null 2>
&
1
#
# Function that stops the daemon/service
#
do_stop()
# Return
#0 if daemon has been stopped
#1 if daemon was already stopped
#2 if daemon could not be stopped
#other if a failure occurred
start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PID --name $NAME
RETVAL="$?"
sleep 1
return "$RETVAL"
#
# Function that sends a SIGHUP to the daemon/service
#
do_reload()
start-stop-daemon --stop --signal HUP --quiet --pidfile $PID --name $NAME
return 0
#
# Rotate log files
#
do_rotate()
start-stop-daemon --stop --signal USR1 --quiet --pidfile $PID --name $NAME
return 0
#
# Online upgrade nginx executable
#
# "Upgrading Executable on the Fly"
# http://nginx.org/en/docs/control.html
#
do_upgrade()
# Return
#0 if nginx has been successfully upgraded
#1 if nginx is not running
#2 if the pid files were not created on time
#3 if the old master could not be killed
if start-stop-daemon --stop --signal USR2 --quiet --pidfile $PID --name $NAME;
then
# Wait for both old and new master to write their pid file
while [ ! -s "$PID.oldbin" ] || [ ! -s "$PID" ];
do
cnt=`expr $cnt + 1`
if [ $cnt -gt 10 ];
then
return 2
fi
sleep 1
done
# Everything is ready, gracefully stop the old master
if start-stop-daemon --stop --signal QUIT --quiet --pidfile "$PID.oldbin" --name $NAME;
then
return 0
else
return 3
fi
else
return 1
fi
case "$1" in
start)
[ "$VERBOSE" != no ] &
&
log_daemon_msg "Starting $DESC" "$NAME"
do_start
case "$?" in
0|1) [ "$VERBOSE" != no ] &
&
log_end_msg 0 ;
;
2) [ "$VERBOSE" != no ] &
&
log_end_msg 1 ;
;
esac
;
;
stop)
[ "$VERBOSE" != no ] &
&
log_daemon_msg "Stopping $DESC" "$NAME"
do_stop
case "$?" in
0|1) [ "$VERBOSE" != no ] &
&
log_end_msg 0 ;
;
2) [ "$VERBOSE" != no ] &
&
log_end_msg 1 ;
;
esac
;
;
restart)
log_daemon_msg "Restarting $DESC" "$NAME"
# Check configuration before stopping nginx
if ! test_nginx_config;
then
log_end_msg 1 # Configuration error
exit 0
fi
do_stop
case "$?" in
0|1)
do_start
case "$?" in
0) log_end_msg 0 ;
;
1) log_end_msg 1 ;
;
# Old process is still running
*) log_end_msg 1 ;
;
# Failed to start
esac
;
;
*)
# Failed to stop
log_end_msg 1
;
;
esac
;
;
reload|force-reload)
log_daemon_msg "Reloading $DESC configuration" "$NAME"
# Check configuration before reload nginx
#
# This is not entirely correct since the on-disk nginx binary
# may differ from the in-memory one, but thats not common.
# We prefer to check the configuration and return an error
# to the administrator.
if ! test_nginx_config;
then
log_end_msg 1 # Configuration error
exit 0
fi
do_reload
log_end_msg $?
;
;
configtest|testconfig)
log_daemon_msg "Testing $DESC configuration"
test_nginx_config
log_end_msg $?
;
;
status)
status_of_proc -p $PID
推荐阅读
- AIX之设备管理总结篇
- 《游戏设计模式》笔记(更新中)
- IDEPCIISASCSI的区别
- Service中是如何产生ANR的()
- AIX之设备管理
- 路由基础之OSPF LSA详细讲解
- Fiori 应用通过 Adaptation Project 的增强方式分享
- Linux之常见命令总结篇
- Spring框架系列(10) - Spring AOP实现原理详解之AOP代理的创建